const config = new JsonConfigFile(
    "./plugins/QxYs/config.json",
    JSON.stringify({
        requiredExperience: 0, // 需要最小经验等级
        enableNightVision: false, // 是否开启夜视
        double_plant: true, // 是否需要躲在高草从下
        time: 0.1, // 刷新时间(秒)
    })
), invisibilityTag = "sneakInvisibility";

mc.regPlayerCmd("glys", "打开GLYS配置表单", (pl, args) => {
    if (pl.isOP()) {
        let form = mc.newCustomForm();
        form.setTitle("GLYS 配置");
        form.addInput("需要最小经验等级", "请输入经验等级", config.get("requiredExperience").toString());
        form.addSwitch("是否开启夜视", config.get("enableNightVision"));
        form.addSwitch("是否需要躲在高草从下", config.get("double_plant"));

        pl.sendForm(form, (player, data) => {
            if (data !== null) {
                const requiredExperience = parseInt(data[0]);
                const enableNightVision = data[1];
                const double_plant = data[2];

                config.set("requiredExperience", requiredExperience);
                config.set("enableNightVision", enableNightVision);
                config.set("double_plant", double_plant);

                player.tell("配置已更新");
            } else {
                player.tell("配置更新已取消");
            }
        });
    } else {
        pl.tell("你没有权限使用这个命令");
    }
    return false; 
});

setInterval(() => {
    mc.getOnlinePlayers().forEach(player => {
        if (player.getLevel() < config.get("requiredExperience")) return;
        
        if (player.removeTag(invisibilityTag)) {
            player.removeEffect(14);
            if (config.get("enableNightVision")) player.removeEffect(16);
        }

        const block = mc.getBlock(player.blockPos);
        if (
            player.getAllEffects().includes(14) ||
            (config.get("double_plant") && (!block || block.type !== "minecraft:double_plant")) ||
            !player.isSneaking
        ) return;

        player.addEffect(14, 2147483647, 1, false);
        if (config.get("enableNightVision")) player.addEffect(16, 2147483647, 1, false);
        player.addTag(invisibilityTag);
    });
}, config.get('time') * 1000); 
